<template>
  <div class="echarts-wrapper echartsAlternating">
    <div class="echarts-content" ref="alternating">

    </div>
    <div class="titleShow">
        <p><i></i><span class="textTitle">告警机房总数:</span><span class="textValue">150</span></p>
        <p><i></i><span class="textTitle">告警机房数比例:</span><span class="textValue">50</span></p>
    </div>
  </div>
</template>

<script>
import * as echarts from 'echarts';

export default {
  name: "histogramAlternating",
  chart: "",
  props: {
    id: {
      require: true,
      type: String,
      default: "",
    },
    name: {
      type: String,
      default: ""
    },
    top: {
      type: Number,
      default: 15,
    },
    bottom: {
      type: Number,
      default: 60
    },
    space: {
      type: Number,
      default: 4
    },
  },
  data() {
    return {

    }
  },
  methods: {
    setOption(opt) {
      this.$options.chart.setOption(opt);
    },
    setData(data) {
        /*
        // 统计数据
        data:{
            dataList:[32, 43, 17, 27],
            dataName:['过压数量', '欠压数量', '缺项数量', '过流数量']
        }
        */ 
        
    const sideData = data.dataList.map(item => item + 1);//右边的面稍高一点

    let option = {
            // backgroundColor: "#ffffff",
            tooltip: {
                trigger: 'axis',
                formatter: "{b} : {c}",
                axisPointer: { // 坐标轴指示器，坐标轴触发有效
                    type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
                }
            },
            xAxis: {
                data: data.nameList,
                //坐标轴
                axisLine: {
                    lineStyle: {
                        color: '#ccc'
                    }
                },
                //坐标值标注
                axisLabel: {
                    show: true,
                    textStyle: {
                        color: '#fff',
                    }
                }
            },
            yAxis: {
                //坐标轴
                axisLine: {
                    show: true,
                    lineStyle: {
                        color: '#ccc'
                    }
                },
                //坐标值标注
                axisLabel: {
                    show: true,
                    textStyle: {
                        color: '#fff',
                    }
                },
                //分格线
                splitLine: {
                    show:false,
                    lineStyle: {
                        color: '#000'
                    }
                }
            },
            series: [{
                name: '交流ABC',
                tooltip: {
                    show: true,
                    position: 'top'
                },
                type: 'bar',
                barWidth: 24.5,
                markPoint: {
                        itemStyle:{
                            color: new echarts.graphic.LinearGradient(0, 0, 1, 0, [{
                                offset: 0,
                                color: "#0077EA" // 0% 处的颜色
                            }, {
                                offset: 1,
                                color: "#451DD3" // 100% 处的颜色
                            }], false),
                            borderColor:new echarts.graphic.LinearGradient(0, 0, 1, 0, [{
                                offset: 0,
                                color: "rgba(190,215,253,0.4)", // 0% 处的颜色 BED7FD
                            }, {
                                offset: 1,
                                color: "rgba(90,100,248,0.4)", // 100% 处的颜色 5A64F8
                            }], false),
                        },
                        data: [
                            {name: '年最高', value: 32, xAxis: 0, yAxis: 34},
                            {name: '年最高', value: 43, xAxis: 1, yAxis: 45},
                            {name: '年最高', value: 17, xAxis: 2, yAxis: 19},
                            {name: '年最高', value: 27, xAxis: 3, yAxis: 29},
                        ]
                    },
                itemStyle: {
                    normal: {
                        color: new echarts.graphic.LinearGradient(0, 1, 0, 0, [{
                            offset: 0,
                            color: "#451DD3" // 0% 处的颜色
                        }, {
                            offset: 1,
                            color: "#0077EA" // 100% 处的颜色
                        }], false)
                    }
                },
                data: data.dataList,
                barGap: 0
            }, {
                type: 'bar',
                barWidth: 6.5,
                itemStyle: {
                    normal: {
                        color: new echarts.graphic.LinearGradient(0, 1, 0, 0, [{
                            offset: 0,
                            color: "#2663DA" // 0% 处的颜色
                        }, {
                            offset: 1,
                            color: "#69CCF6" // 100% 处的颜色
                        }], false)
                    }
                },
                barGap: 0,
                data: sideData
            }, {
                name: 'b',
                tooltip: {
                    show: false
                },
                type: 'pictorialBar',
                itemStyle: {
                    borderWidth: 1,
                    borderColor: '#00B6EE',
                    color: '#00B6EE'
                },
                symbol: 'path://M 0,0 l 120,0 l -30,60 l -120,0 z',
                symbolSize: ['30', '12'],
                symbolOffset: ['0', '-11'],
                //symbolRotate: -5,
                symbolPosition: 'end',
                data: data.dataList,
                z: 3
            }]
        };
        this.setOption(option);
    },
    resize() {
      this.$options.chart.resize();
    }
  },
  mounted() {
    // 基于准备好的dom，初始化echarts实例
    this.$options.chart = echarts.init(this.$refs.alternating);

    window.addEventListener('resize', this.resize);
  },
  destroyed() {
    window.removeEventListener('resize', this.resize);
  }
}
</script>

<style scoped>
    .echartsAlternating{
        position:relative;
    }
    .titleShow{
        width: 100%;
        height: 100px;
        position: absolute;
        top: 3%;
        right: 10%;
        text-align: right;

    }
    .titleShow i{
        display: inline-block;
        width: 5px;
        height: 5px;
        border-radius: 50%;
        background: rgb(246,127,33);
        margin-right: 5px;
        margin-bottom: 3px;
    }
    .titleShow .textTitle{
        display: inline-block;
        width: 120px;
        text-align: right;
        color: rgb(0,178,224);
    }
    .titleShow .textValue{
        display: inline-block;
        width: 80px;
        /* text-align: left; */
        text-align: left;
        color: rgb(246,127,33);
    }
</style>